/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/getcpu.c,v 1.1 1993/02/11 21:43:13 mcooper Exp mcooper $";
#endif

/*
 * Get cpu type information
 */

#include "defs.h"

#if	defined(HAVE_SYSINFO)
/*
 * Get cpu type using sysinfo() system call.
 */
static char *GetCpuTypeFromSysinfo()
{
    static char			buff[BUFSIZ];

    if (buff[0])
	return(buff);

    if (sysinfo(SI_ARCHITECTURE, buff, sizeof(buff)) < 0)
	return((char *) NULL);

    return(buff);
}
#endif	/* HAVE_SYSINFO */

/*
 * Get CPU type
 */
extern char *GetCPU()
{
    static char		       *cpu = NULL;
    extern char		       *CPUFiles[];
    extern char		       *AppArchCmds[];

    if (cpu)
	return(cpu);

#if	defined(CPU_NAME)
    if (!cpu)
	cpu = CPU_NAME;
#endif	/* CPU_NAME */

#if	defined(HAVE_SYSINFO)
    /*
     * Try the system sysinfo() call
     */
    if (!cpu)
	cpu = GetCpuTypeFromSysinfo();
#endif	/* HAVE_SYSINFO */

#if	defined(HAVE_HOST_INFO)
    /*
     * Try the Mach method.
     * This should be in os-mach.c, but this is the only
     * OS specific case so far.
     */
    if (!cpu)
	cpu = (char *) GetCpuTypeFromHostInfo();
#endif 	/* HAVE_HOST_INFO */

    if (!cpu) {
	cpu = RunTestFiles(CPUFiles);

	/*
	 * If that didn't work, try the architecture commands.
	 */
	if (!cpu)
	    cpu = RunCmds(AppArchCmds);
    }

    return(cpu);
}

