/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/getkernver.c,v 1.13 1993/06/08 20:14:03 mcooper Exp mcooper $";
#endif


/*
 * Kernel related functions.
 */

#include "defs.h"

#if	defined(HAVE_KERNELVERSION)
#include <fcntl.h>
#include <nlist.h>

char 				VersionSYM[] = "_version";

/*
 * Get kernel version string by reading the
 * symbol "version" from the kernel.
 */
static char *GetKernelVersionFromVersion()
{
    struct nlist	       *nlptr;
    static struct nlist	        nlbuff;
    static char			Buf[BUFSIZ];
    register char	       *p;
    kvm_t		       *kd;

    if (kd = KVMopen()) {
	/*
	 * Using "nlbuff" is necessary to avoid a sun386i SunOS 4.0.1 bug.
	 */
	if ((nlptr = KVMnlist(kd, VersionSYM, &nlbuff)) == NULL)
	    return((char *) NULL);

	if (CheckNlist(nlptr))
	    return((char *) NULL);

	if (KVMread(kd, nlptr->n_value, (char *) Buf, sizeof(Buf))) {
	    if (Debug) Error("Read of \"%s\" from kernel failed.",
			     VersionSYM);
	    Buf[0] = C_NULL;
	}
    }

    if (kd)
	KVMclose(kd);

#if	defined(KERNSTR_END)
    /*
     * Truncate extraneous info
     */
    if (Buf[0])
	if ((p = index(Buf, KERNSTR_END)) != NULL)
	    *p = C_NULL;
#endif	/* KERNSTR_END */

    return( (Buf[0]) ? Buf : (char *) NULL);
}
#endif	/* HAVE_KERNELVERSION */

/*
 * Get kernel version string
 */
extern char *GetKernelVersion()
{
    static char		       *str = NULL;

    if (str)
	return(str);

#if	defined(HAVE_KERNELVERSION)
    if (!str)
	str = GetKernelVersionFromVersion();
#endif	/* HAVE_KERNELVERSION */

#if	defined(HAVE_KERNELVERSION_OSSPEC)
    if (!str)
	str = GetKernelVersionStr();
#endif	/* HAVE_KERNELVERSION_OSSPEC */

    return(str);
}

