/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/getman.c,v 1.2 1993/04/16 19:32:46 mcooper Exp mcooper $";
#endif

/*

 * Get architecture information
 */

#include "defs.h"

/*
 * Get the short manufacturer name
 */
extern char *GetManShort()
{
    static char			buff[BUFSIZ];
    char		       *cp;

    buff[0] = C_NULL;
#if	defined(MAN_SHORT)
    if (!buff[0])
	(void) strcpy(buff, MAN_SHORT);
#endif	/* MAN_SHORT */

#if	defined(HAVE_SYSINFO)
    if (!buff[0]) {
	if (sysinfo(SI_HW_PROVIDER, buff, sizeof(buff)) < 0)
	    Error("sysinfo SI_HW_PROVIDER failed.");
	else {
	    if (cp = index(buff, '_'))
		*cp = C_NULL;
	}
    }
#endif	/* HAVE_SYSINFO */

    return((buff[0]) ? buff : (char *)NULL);
}

/*
 * Get the long manufacturer name
 */
extern char *GetManLong()
{
    static char			buff[BUFSIZ];
    register char	       *cp;

    buff[0] = C_NULL;
#if	defined(MAN_LONG)
    if (!buff[0])
	(void) strcpy(buff, MAN_LONG);
#endif	/* MAN_LONG */

#if	defined(HAVE_SYSINFO)
    if (!buff[0]) {
	if (sysinfo(SI_HW_PROVIDER, buff, sizeof(buff)) < 0)
	    Error("sysinfo SI_HW_PROVIDER failed.");
	else {
	    cp = buff;
	    while (cp && (cp = index(cp, '_')))
		*cp++ = ' ';
	}
    }
#endif	/* HAVE_SYSINFO */

    return((buff[0]) ? buff : (char *)NULL);
}

/*
 * Get the manufacturer info.
 */
extern char *GetMan()
{
    char 		       *ms, *ml;
    static char 		Buf[BUFSIZ];

    ms = GetManShort();
    ml = GetManLong();

    if (!Terse)
	(void) sprintf(Buf, "%s (%s)", ms, ml);
    else
	(void) sprintf(Buf, "%s", ms);

    return(Buf);
}

