/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/info-next.c,v 1.9 1993/02/11 21:43:13 mcooper Exp mcooper $";
#endif


/*
 * NeXT related information
 */

#include "defs.h"

/*
 * Kernel variable containing model number.
 */
char				MachineTypeSYM[] = "_machine_type";

/*
 * Kernel symbol for the device table
 */
char				NeXTBusSYM[] = "_bus_dinit";

/*
 * Models of NeXT machines as defined in <next/scr.h>
 */
#include <next/scr.h>
NAMETAB ModelTab[] = {
#ifdef NeXT_CUBE
    {  NeXT_CUBE, 	"NeXTCube (MC68030)" },
#endif
#ifdef NeXT_WARP9
    {  NeXT_WARP9,	"NeXTStation" },
#endif
#ifdef NeXT_X15
    {  NeXT_X15,	"NeXTCube (MC68040)" },
#endif
#ifdef NeXT_WARP9C
    {  NeXT_WARP9C,	"NeXTWarp9C" },
#endif
    {  0 },
};

/*
 * Device Data Table
 */
DEVDATATAB DevDataTab[] = {
    { "sc",	NULL,	"SCSI Controller", 		NULL },
    { "odc",	NULL,	"Optical Disk Controller", 	NULL },
    { "fdc",	NULL,	"Floppy Disk Controller", 	NULL },
    { "sd",	NULL,	NULL,				ProbeDiskDrive },
    { "od",	NULL,	NULL,				ProbeDiskDrive },
    { "fd",	NULL,	NULL,				ProbeDiskDrive },
    { "en",	"EtherNet Interface","10Mb/sec Ethernet",ProbeNetif },
    { "dsp",	NULL,	"Digital Signal Processor", 	ProbeGeneric },
    { "np",	NULL,	"NeXT Printer",		 	ProbeGeneric },
    /*
     * These devices are usually indicated as present, but may only
     * exist as device drivers so we ignore them.
     */
    { "sg",	NULL,	NULL,				NULL },
    { "sound",	NULL,	NULL,				NULL },
    {  0 },
};
