.\"
.\" Copyright (c) 1992-1993 Michael A. Cooper.
.\" This software may be freely distributed provided it is not sold for 
.\" profit and the author is credited appropriately.
.\"
.\" $Header: /src/common/usc/bin/sysinfo/RCS/sysinfo.man,v 1.17 1993/04/19 19:48:18 mcooper Exp mcooper $
.\" 
.TH SYSINFO 1 "16 April 1993"
.ds ]W USC-UCS
.SH NAME
sysinfo \- Display system information
.SH SYNOPSIS
sysinfo
[
.B +|\-all
] 
[
.B \-debug
]
[
.B \-level
.I level1,level2,...
]
[
.B \-offset 
.I amount
]
[
.B \-show
.I item1,item2,...
] 
[
.B +|\-terse
] 
[
.B +|\-unknown
] 
[
.B +|\-useprom
] 
.br
.sp
sysinfo 
.B \-list
[
.B level|show
]
.br
.sp
sysinfo 
.B \-version
.SH DESCRIPTION
.I Sysinfo
displays certain pieces of system information for the current host.
By default, 
.I sysinfo
displays all system information it knows about in verbose mode.
This includes:
.IP *
Host name
.IP *
Host name aliases
.IP *
Host network addresses
.IP *
Host ID
.IP *
System serial number
.IP *
Manufacturer of the system's hardware
.IP *
CPU model name
.IP *
CPU type
.IP *
Application architecture
.IP *
Kernel architecture
.IP *
Amount of main memory
.IP *
Operating system name
.IP *
Operating system version
.IP *
Kernel version
.IP *
A variety of information about devices.
.PP
By default,
.B sysinfo
will display most info items it knows about.
Specific items may be exclusively shown by using the
.B \-show
option and specifying a comma seperated list of items.
.PP
If the file
.I /etc/sysmodel
exists, the first line of the file is read and used as the
system model name.
.SH OPTIONS
.IP "\fB+|-all\fP"
Enable (\fB+all\fP) or disable (\fB\-all\fP) displaying all known information.
This option is enabled by default.
.IP "\fB\-debug\fR"
Enable debugging messages.
This includes printing all error messages that are normally
not shown.
.IP "\fB\-level \fIlevels\fR"
Set the show level.
.I levels
is a comma seperated list of values used to determine what
levels of information will be displayed.
Use the
.B "\-list level"
option to get a list of valid 
.I levels.
.IP "\fB\-list [ level|show ]\fR"
List all the possible values that may be used with an option.
Specifying
.B "\-list show"
will list possible values for use with the
.B \-show
option.
Specifying
.B "\-list level"
will list possible values for use with the
.B \-level
option.
.IP "\fB\-offset \fIamount\fR"
Set the number of spaces to offset (indent) when printing
device information.
.IP "\fB\-show \fIitem1,item2,...\fR"
Show information only about each comma seperated item.
A current list of valid item names can be determined by using the
.B "\-list show"
option.
.IP "\fB+|-terse\fP"
Enable (\fB+terse\fP) or disable (\fB\-terse\fP) showing items in
terse format.
When enabled this 
usually means that the field label for each item is not displayed.
This option is disabled by default.
.IP "\fB+|-unknown\fP"
Enable (\fB+unknown\fP) or disable (\fB\-unknown\fP) showing devices
that appear to be present on the system, but are not "known" to sysinfo.
This option is enabled by default.
.IP "\fB+|-useprom\fP"
Enable (\fB+useprom\fP) or disable (\fB\-useprom\fP) using values
obtained from the system PROM instead of intepreting values obtained
directly from the kernel.
Certain values are normally obtained by looking up a variable in
the kernel and checking the result against a table of values compiled
into 
.B sysinfo.
By enabling this option, 
.B sysinfo
will attempt to obtain certain values from the system PROM.
This support is currently limited to the
.B "System Model"
value.
Support is also limited to those machines which support such
a system PROM.
.IP "\fB-version\fP"
Show version
information for
.I sysinfo.
.SH AUTHOR
Michael A. Cooper, 
.br
University Computing Services, 
.br
University of Southern California.
.SH FILES
.sp
/etc/sysmodel	\- Explicitly set the CPU model name
.SH SEE ALSO
gethostid(2), gethostname(2), gethostbyname(3)
.SH DIAGNOSTICS
.IP "\fI%x: Unknown CPU type.\fP"
The CPU model for the current host could not be determined.
.IP "(unknown)"
Information could not be determined for this item.
.SH BUGS
.PP
Not all operating systems support interfaces to various pieces of
information that sysinfo supports.
.PP
Some devices, mostly devices that use 
removable media such as
tape drives and floppy disks, are only indicated (shown) as
present if media is loaded in the device and it's on-line.
This occurs because the OS does not provide a software
interface to query the device when media is not loaded.
.PP
.B SunOS 
allows only one process at a time to have
.B /dev/openprom
open.
This may result in certain pieces of information 
not always showing up consistantly.  When in doubt,
enable debugging
.B (\-debug).
.PP
The 
.B "Serial Number"
field when run under
.B SunOS
will show the serial number as obtained from the system's
.B IDPROM.
This serial number has no correspondence with the system serial
number that appears on the back of your machine.
.PP
Under
.B SunOS
there is no way to tell the difference between an MC68020 (like the
3/60) and MC68030 (like the 3/80)
based machine.
.PP
Under 
.B Ultrix
it's virtually impossible to determine the actual
.B "System Model"
for 
.B VAX
and 
.B "DEC MIPS"
based machines.
