/*
 * Copyright (c) 1992-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

#ifndef lint
static char *RCSid = "$Header: /src/common/usc/bin/sysinfo/RCS/virtmem.c,v 1.1 1993/06/08 18:15:07 mcooper Exp mcooper $";
#endif


/*
 * Virtual Memory related functions.
 */

#include "defs.h"

#if	VIRTMEM_TYPE == VIRTMEM_ANONINFO

#include <nlist.h>
#include <vm/anon.h>

static char			AnonInfoSYM[] = "_anoninfo";

static off_t
GetVirtMemAmount()
{
    kvm_t		       *kd;
    static struct anoninfo	AnonInfo;
    off_t			Amount = 0;
    struct nlist	       *nlPtr;

    if (kd = KVMopen()) {
	if ((nlPtr = KVMnlist(kd, AnonInfoSYM, (struct nlist *)NULL)) == NULL)
	    return(0);

	if (CheckNlist(nlPtr))
	    return(0);

	if (KVMread(kd, nlPtr->n_value, (char *) &AnonInfo, 
		    sizeof(AnonInfo)) >= 0)
	    Amount = (off_t) (AnonInfo.ani_free + AnonInfo.ani_resv);

	if (Amount)
	    Amount = (Amount * getpagesize()) / KBYTES;

	KVMclose(kd);
    }

    return(Amount);
}
#endif	/* VIRTMEM_TYPE == VIRTMEM_ANONINFO */

#if	!defined(VIRTMEM_TYPE)
static off_t
GetVirtMemAmount()
{
    if (Debug) printf("No support for getting Virtual Memory info.\n");
    return(0);
}
#endif	/* !VIRTMEM_TYPE */

/*
 * Get Virtual Memory string
 */
extern char *
GetVirtMem()
{
    static char			Buff[BUFSIZ];
    off_t			Amount;

    /*
     * GetVirtMemAmount() should always return Amount in kilobytes
     */
    Amount = GetVirtMemAmount();
    if (Amount == 0)
	return((char *) NULL);

    (void) sprintf(Buff, "%d MB", kbytes_to_mbytes(Amount));

    return(Buff);
}
